<?php

class Cierres extends CI_Controller {
    
    function __construct() {
        parent::__construct();
                if((!$this->session->userdata('session_id')) || (!$this->session->userdata('logado'))) {
                    redirect('mapos/login');
                }
        
        $this->load->helper(array('form','codegen_helper'));
        $this->load->model('cierres_model','',TRUE);
        $this->data['menuCierres'] = 'Cierres';
    }   
    
    function index(){
        $this->gerenciar();
    }

    function gerenciar(){
        
        $this->load->library('pagination');
        
        
        $config['base_url'] = base_url().'index.php/cierres/gerenciar/';
        $config['total_rows'] = $this->cierres_model->count('cierres');
        $config['per_page'] = 10;
        $config['next_link'] = 'Próxima';
        $config['prev_link'] = 'Anterior';
        $config['full_tag_open'] = '<div class="pagination alternate"><ul>';
        $config['full_tag_close'] = '</ul></div>';
        $config['num_tag_open'] = '<li>';
        $config['num_tag_close'] = '</li>';
        $config['cur_tag_open'] = '<li><a style="color: #2D335B"><b>';
        $config['cur_tag_close'] = '</b></a></li>';
        $config['prev_tag_open'] = '<li>';
        $config['prev_tag_close'] = '</li>';
        $config['next_tag_open'] = '<li>';
        $config['next_tag_close'] = '</li>';
        $config['first_link'] = 'Primera';
        $config['last_link'] = 'Última';
        $config['first_tag_open'] = '<li>';
        $config['first_tag_close'] = '</li>';
        $config['last_tag_open'] = '<li>';
        $config['last_tag_close'] = '</li>';
            
        $this->pagination->initialize($config);     

        $this->data['results'] = $this->cierres_model->get('cierres','idCierres,dataInicial,observacion,recaudado,favor,contra','',$config['per_page'],$this->uri->segment(3));
       
        $this->data['view'] = 'cierres/cierres';
        $this->load->view('tema/topo',$this->data);
    }
    
    function adicionar(){

        $this->load->library('form_validation');
        $this->data['custom_error'] = '';
        
        if ($this->form_validation->run('cierres') == false) {
           $this->data['custom_error'] = (validation_errors() ? true : false);
        } else {

            $dataInicial = $this->input->post('dataInicial');

            try {
                
                $dataInicial = explode('/', $dataInicial);
                $dataInicial = $dataInicial[2].'-'.$dataInicial[1].'-'.$dataInicial[0];

            } catch (Exception $e) {
               $dataInicial = date('Y/m/d'); 
            }

            $data = array(
                'dataInicial' => $dataInicial,
                'usuarios_id' => $this->input->post('usuarios_id'),//set_value('idUsuario'),
                'observacion' => set_value('observacion'),
                'cajafija' => set_value('cajafija'),
                'conteorapido' => 0,
                'dinero' => 0,
                'recaudado' => 0,
                'dia' => 0,
                'egresos' => 0,
                'favor' => 0,
                'contra' => 0,
                'ingresos' => 0,
                'recarga' => 0
            );

            if ( is_numeric($id = $this->cierres_model->add('cierres', $data, true)) ) {
                $this->session->set_flashdata('success','El cierre se agregó correctamente, puede agregar detalle del cierre."!');

                //Guarda cierres detalle
                $data_detalle = array(
                    'cierres_id' => $id,
                    'can001' => 0, 'tot001' => 0, 'can005' => 0, 'tot005' => 0, 'can01' => 0, 'tot01' => 0,
                    'can025' => 0, 'tot025' => 0, 'can05' => 0, 'tot05' => 0, 'can1' => 0, 'tot1' => 0,
                    'can5' => 0, 'tot5' => 0, 'can10' => 0, 'tot10' => 0, 'can20' => 0, 'tot20' => 0,
                    'can50' => 0, 'tot50' => 0, 'can100' => 0, 'tot100' => 0,
                    'cab_actual' => 0, 'cab_anterior' => 0, 'telefonia' => 0, 'cyber' => 0, 'otros1' => 0, 'otros2' => 0,
                    'recargas' => 0,'recargas_cab' => 0,'creditos' => 0,'facturas' => 0,'otros_egresos' => 0,'recargas_uno' => 0    
                );

                $idCierresDetalle = $this->cierres_model->add('cierres_detalle', $data_detalle, true);


                redirect('cierres/editar/'.$id);

            } else {
                
                $this->data['custom_error'] = '<div class="form_error"><p>A ocurrido un Error.</p></div>';
            }
        }
         
        $this->data['view'] = 'cierres/adicionarCierre';
        $this->load->view('tema/topo', $this->data);
    }
    
    public function adicionarAjax(){
        $this->load->library('form_validation');

        if ($this->form_validation->run('cierres') == false) {
           $json = array("result"=> false);
           echo json_encode($json);
        } else {
            $data = array(
                'dataInicial' => set_value('dataInicial'),
                'clientes_id' => $this->input->post('clientes_id'),//set_value('idCliente'),
                'usuarios_id' => $this->input->post('usuarios_id'),//set_value('idUsuario'),
                'dataFinal' => set_value('dataFinal'),
                'garantia' => set_value('garantia'),
                'descricaoProduto' => set_value('descricaoProduto'),
                'defeito' => set_value('defeito'),
                'status' => set_value('status'),
                'observacoes' => set_value('observacoes'),
                'laudoTecnico' => set_value('laudoTecnico')
            );

            if ( is_numeric($id = $this->os_model->add('os', $data, true)) ) {
                $json = array("result"=> true, "id"=> $id);
                echo json_encode($json);

            } else {
                $json = array("result"=> false);
                echo json_encode($json);

            }
        }
         
    }

    function editar() {
        $this->load->library('form_validation');
        $this->data['custom_error'] = '';

        if ($this->form_validation->run('cierres') == false) {
            $this->data['custom_error'] = (validation_errors() ? '<div class="form_error">' . validation_errors() . '</div>' : false);
        } else {

            $dataInicial = $this->input->post('dataInicial');
        
            try {
                
                $dataInicial = explode('/', $dataInicial);
                $dataInicial = $dataInicial[2].'-'.$dataInicial[1].'-'.$dataInicial[0];


            } catch (Exception $e) {
               $dataInicial = date('Y/m/d'); 
            }

            $data = array(
                'usuarios_id' => $this->input->post('usuarios_id'),
                'dataInicial' => $dataInicial,
                'observacion' => $this->input->post('observacion'),
                'cajafija' => $this->input->post('cajafija'),
                'conteorapido' => $this->input->post('conteorapido'),
                'dinero' => $this->input->post('dinero'),
                'recaudado' => $this->input->post('recaudado'),
                'dia' => $this->input->post('dia'),
                'egresos' => $this->input->post('egresos'),
                'favor' => $this->input->post('favor'),
                'contra' => $this->input->post('contra'),
                'ingresos' => $this->input->post('ingresos'),
                'recarga' => $this->input->post('recarga')
            );

            if ($this->cierres_model->edit('cierres', $data, 'idCierres', $this->input->post('idCierres')) == TRUE) {
                $this->session->set_flashdata('success','Cierre editado con éxito!');
                
                 //Guarda cierres detalle
                 $data_detalle = array(
                    'can001' => $this->input->post('can001'), 'tot001' => $this->input->post('tot001'), 'can005' => $this->input->post('can005'), 'tot005' => $this->input->post('tot005'), 'can01' => $this->input->post('can01'), 'tot01' => $this->input->post('tot01'),
                    'can025' => $this->input->post('can025'), 'tot025' => $this->input->post('tot025'), 'can05' => $this->input->post('can05'), 'tot05' => $this->input->post('tot05'), 'can1' => $this->input->post('can1'), 'tot1' => $this->input->post('tot1'),
                    'can5' => $this->input->post('can5'), 'tot5' => $this->input->post('tot5'), 'can10' => $this->input->post('can10'), 'tot10' => $this->input->post('tot10'), 'can20' => $this->input->post('can20'), 'tot20' => $this->input->post('tot20'),
                    'can50' => $this->input->post('can50'), 'tot50' => $this->input->post('tot50'), 'can100' => $this->input->post('can100'), 'tot100' => $this->input->post('tot100'),
                    'cab_actual' => $this->input->post('cab_actual'), 'cab_anterior' => $this->input->post('cab_anterior'), 'telefonia' => $this->input->post('telefonia'), 'cyber' => $this->input->post('cyber'), 'otros1' => $this->input->post('otros1'), 'otros2' => $this->input->post('otros2'),
                    'recargas' => $this->input->post('recargas'),'recargas_cab' => $this->input->post('recargas_cab'),'creditos' => $this->input->post('creditos'),'facturas' => $this->input->post('facturas'),'otros_egresos' => $this->input->post('otros_egresos'),'recargas_uno' => $this->input->post('recargas_uno')    
                );
                if ($this->cierres_model->edit('cierres_detalle', $data_detalle, 'cierres_id', $this->input->post('idCierres')) == TRUE) {}

                redirect(base_url() . 'index.php/cierres/editar/'.$this->input->post('idCierres'));
            } else {
                $this->data['custom_error'] = '<div class="form_error"><p>A ocurrido un error</p></div>';
            }
        }

        $this->data['result'] = $this->cierres_model->getById($this->uri->segment(3));
        $this->data['result_detalle'] = $this->cierres_model->getDetalle($this->uri->segment(3));
     
        $this->data['view'] = 'cierres/editarCierre';
        $this->load->view('tema/topo', $this->data);
    }

    public function visualizar(){

        $this->data['custom_error'] = '';
        $this->load->model('mapos_model');
        $this->data['result'] = $this->cierres_model->getById($this->uri->segment(3));
        $this->data['result_detalle'] = $this->cierres_model->getDetalle($this->uri->segment(3));
        $this->data['emitente'] = $this->mapos_model->getEmitente();
        $this->data['view'] = 'cierres/visualizarCierre';
        $this->load->view('tema/topo', $this->data);
    }
    
    function excluir(){

        $id =  $this->input->post('id');
        if ($id == null){

            $this->session->set_flashdata('error','Error al intentar eliminar Cierre.');            
            redirect(base_url().'index.php/cierres/gerenciar/');
        }

        $this->db->where('cierres_id', $id);
        $this->db->delete('cierres_detalle');

        $this->cierres_model->delete('cierres','idCierres',$id);             

        $this->session->set_flashdata('success','Cierre eliminado con éxito!');            
        redirect(base_url().'index.php/cierres/gerenciar/');
    }

    public function autoCompleteUsuario(){

        if (isset($_GET['term'])){
            $q = strtolower($_GET['term']);
            $this->cierres_model->autoCompleteUsuario($q);
        }

    }
}

