<?php
class Cierres_model extends CI_Model {

    function __construct() {
        parent::__construct();
    }

    
    function get($table,$fields,$where='',$perpage=0,$start=0,$one=false,$array='array'){
        
        $this->db->select($fields.',usuarios.nome');
        $this->db->from($table);
        $this->db->join('usuarios','usuarios.idUsuarios = cierres.usuarios_id');
        $this->db->limit($perpage,$start);
        $this->db->order_by('idCierres','desc');
        if($where){
            $this->db->where($where);
        }
        
        $query = $this->db->get();
        
        $result =  !$one  ? $query->result() : $query->row();
        return $result;
    }

    function getById($id){
        $this->db->select('cierres.*, usuarios.telefone, usuarios.email, usuarios.nome');
        $this->db->from('cierres');
        $this->db->join('usuarios','usuarios.idUsuarios = cierres.usuarios_id');
        $this->db->where('cierres.idCierres',$id);
        $this->db->limit(1);
        return $this->db->get()->row();
    }

    public function getDetalle($id = null){
        $this->db->select('*');
        $this->db->from('cierres_detalle');
        $this->db->where('cierres_id',$id);
        return $this->db->get()->result();
    }

    function add($table,$data,$returnId = false){
        $this->db->insert($table, $data);         
        if ($this->db->affected_rows() == '1')
        {
            if($returnId == true){
                return $this->db->insert_id($table);
            }
            return TRUE;
        }
        
        return FALSE;       
    }
    
    function edit($table,$data,$fieldID,$ID){
        $this->db->where($fieldID,$ID);
        $this->db->update($table, $data);

        if ($this->db->affected_rows() >= 0)
        {
            return TRUE;
        }
        
        return FALSE;       
    }
    
    function delete($table,$fieldID,$ID){
        $this->db->where($fieldID,$ID);
        $this->db->delete($table);
        if ($this->db->affected_rows() == '1')
        {
            return TRUE;
        }
        
        return FALSE;        
    }   

    function count($table){
    return $this->db->count_all($table);
    }

    public function autoCompleteProduto($q){

        $this->db->select('*');
        $this->db->limit(5);
        $this->db->like('descricao', $q);
        $query = $this->db->get('produtos');
        if($query->num_rows > 0){
            foreach ($query->result_array() as $row){
                $row_set[] = array('label'=>$row['descricao'].' | Precio: $ '.$row['precoVenda'].' | Stock: '.$row['estoque'],'estoque'=>$row['estoque'],'id'=>$row['idProdutos'],'preco'=>$row['precoVenda']);
            }
            echo json_encode($row_set);
        }
    }

    public function autoCompleteUsuario($q){

        $this->db->select('*');
        $this->db->limit(5);
        $this->db->like('nome', $q);
        $this->db->where('situacao',1);
        $query = $this->db->get('usuarios');
        if($query->num_rows > 0){
            foreach ($query->result_array() as $row){
                $row_set[] = array('label'=>$row['nome'].' | Teléfono: '.$row['telefone'],'id'=>$row['idUsuarios']);
            }
            echo json_encode($row_set);
        }
    }
}